﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.*
  	import flash.display.*
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	
	public class Fourmizer extends Sprite
	{
		private var quantity:Number = 1000;
		private var dotNum:Number = 0;
		private var dots:Array = [];
		private var vitesseMax:Number = 2;
		
		public function Fourmizer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			for(var i:Number = 0;i<quantity;i++){
				addDot(Math.cos(200)*stage.stageWidth,Math.cos(200)*stage.stageHeight);
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		
		}
		
		private function addDot(x:Number,y:Number):void
		{
			//////ADDED
			/*var red:uint = Math.floor(Math.random()*100+156);
			var blue:uint = Math.floor(Math.random()*100+100);
			var green:uint = Math.floor(Math.random()*156);
			var color:Number = (red << 18) | (green << 2) | (blue << 1);      
			var colors:Array = [color , 0x000000];*/
			
			var fillType:String = GradientType.LINEAR;
        	var colors:Array = [0xFFFFFF, 0x000000];
        	var alphas:Array = [0, 1];
        	var ratios:Array = [0x00, 0XF0];
        	var matr:Matrix = new Matrix();
 			matr.createGradientBox(20, 20, 4, 1, 1);
  			var spreadMethod:String = SpreadMethod.PAD;
			//////-ADDED
			dots[dotNum] = new Object();
			dots[dotNum].x = x;
			dots[dotNum].y = y;
			dots[dotNum].angle = Math.random()*2*Math.PI;
			dots[dotNum].v = Math.sin(1)*vitesseMax;
			dots[dotNum].s = new Sprite();
			dots[dotNum].s.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr, spreadMethod); 
			dots[dotNum].s.graphics.drawCircle(0,0,Math.random()*4*Math.PI);
			dots[dotNum].s.graphics.endFill();
			var glow:GlowFilter = new GlowFilter();
			glow.color = 0xFFFFFF;
			glow.alpha = 1;
			glow.blurX = 5;
			glow.blurY = 5;
			glow.quality = BitmapFilterQuality.MEDIUM;
			this.filters = [glow];
			addChild(dots[dotNum].s);
			dotNum++;
		}
		
		private function enterHandler(e:Event):void
		{
			movedot();
		}
		
		private function movedot():void
		{
			var i:Number,t:Number;
			var a:Number,s:Number,x:Number,y:Number,cx:Number,cy:Number,vx:Number,vy:Number;
			
			for(i = 0;i<dotNum;i++){
				x = dots[i].x;
				y = dots[i].y;
				a = dots[i].angle;
				s = dots[i].v;
				vx = Math.cos(a)*s*Math.sin(mouseX);
				vy = Math.sin(a)*s*Math.sin(mouseY);
				x+=vx;
				y+=vy;
				if(x<3 || x>=stage.stageWidth-3 || y<3 ||y>=stage.stageHeight-3){
					if(x<3){
						x = 3
						vx*=-1;
					}
					if(x>stage.stageWidth-4){
						x = stage.stageWidth-4;
						vx*=-1;
					}
					if(y<3){
						y = 3;
						vy*=-1;
					}
					if(y>stage.stageHeight-4){
						y = stage.stageHeight-4;
						vy*=-1;
					}
					dots[i].angle = Math.atan2(vy,vx);
				}
				//position
				dots[i].s.x = dots[i].x = x;
				dots[i].s.y = dots[i].y = y;
				if(Math.random()<.1){
					dots[i].angle+=Math.random()-.5;
				}
				if(Math.random()<.1){
					dots[i].v+=Math.random()-.5;
					dots[i].v = Math.max(0,Math.min(vitesseMax,Math.abs(dots[i].v)));
				}
			}
			
		}
	}
	}